package com.ekexiu.console.system.dao;

import com.ekexiu.console.system.po.Demand;
import com.ekexiu.console.system.pojo.DemandInfo;
import org.jfw.apt.annotation.Nullable;
import org.jfw.apt.orm.annotation.dao.DAO;
import org.jfw.apt.orm.annotation.dao.method.Exclude;
import org.jfw.apt.orm.annotation.dao.method.From;
import org.jfw.apt.orm.annotation.dao.method.IncludeFixSet;
import org.jfw.apt.orm.annotation.dao.method.OrderBy;
import org.jfw.apt.orm.annotation.dao.method.SetSentence;
import org.jfw.apt.orm.annotation.dao.method.Where;
import org.jfw.apt.orm.annotation.dao.method.operator.PageQuery;
import org.jfw.apt.orm.annotation.dao.method.operator.QueryOne;
import org.jfw.apt.orm.annotation.dao.method.operator.Update;
import org.jfw.apt.orm.annotation.dao.method.operator.UpdateWith;
import org.jfw.apt.orm.annotation.dao.param.Alias;
import org.jfw.apt.orm.annotation.dao.param.GtEq;
import org.jfw.apt.orm.annotation.dao.param.Like;
import org.jfw.apt.orm.annotation.dao.param.LtEq;
import org.jfw.util.PageQueryResult;

import java.sql.Connection;
import java.sql.SQLException;

/**
 * Created by TT on 2017/5/8.
 */
@DAO
public interface DemandDao {

    @Nullable
    @QueryOne
    DemandInfo query(Connection con, String id) throws SQLException;

    @PageQuery
    @Exclude("descp")
    @OrderBy("ORDER BY CREATE_TIME DESC")
    PageQueryResult<DemandInfo> pageQuery(Connection con, @Nullable @Like String title, @Nullable @Like String professorName,@Nullable String state,@Nullable String source, @Nullable @GtEq @Alias("createTime") String bt, @Nullable @Alias("createTime") @LtEq String et, int pageNo, int pageSize)throws SQLException;

    @UpdateWith
    @Where("STATE IN ('0','1')")
    @SetSentence("STATE='3'")
    @IncludeFixSet
    @From(Demand.class)
    int close(Connection con,String id)throws SQLException;

    @UpdateWith
    @Where("STATE IN ('0','1')")
    @SetSentence("STATE='3'")
    @IncludeFixSet
    @From(Demand.class)
    int closeByCreator(Connection con,String creator)throws SQLException;

    @Update
    @Where("STATE IN ('0','1')")
    int update(Connection con,Demand demand) throws SQLException;
}
