package com.ekexiu.console.system.dao;

import com.ekexiu.console.system.po.Product;
import com.ekexiu.console.system.po.ProductPro;
import com.ekexiu.console.system.pojo.ProductInfo;
import org.jfw.apt.annotation.Nullable;
import org.jfw.apt.orm.annotation.dao.DAO;
import org.jfw.apt.orm.annotation.dao.method.Exclude;
import org.jfw.apt.orm.annotation.dao.method.From;
import org.jfw.apt.orm.annotation.dao.method.OrderBy;
import org.jfw.apt.orm.annotation.dao.method.SetSentence;
import org.jfw.apt.orm.annotation.dao.method.Where;
import org.jfw.apt.orm.annotation.dao.method.operator.DeleteWith;
import org.jfw.apt.orm.annotation.dao.method.operator.PageQuery;
import org.jfw.apt.orm.annotation.dao.method.operator.SelectList;
import org.jfw.apt.orm.annotation.dao.method.operator.SelectOne;
import org.jfw.apt.orm.annotation.dao.method.operator.UpdateWith;
import org.jfw.apt.orm.annotation.dao.param.Alias;
import org.jfw.apt.orm.annotation.dao.param.GtEq;
import org.jfw.apt.orm.annotation.dao.param.Like;
import org.jfw.apt.orm.annotation.dao.param.LtEq;
import org.jfw.apt.orm.annotation.dao.param.Set;
import org.jfw.apt.orm.annotation.dao.param.SqlColumn;
import org.jfw.apt.orm.core.defaultImpl.StringHandler;
import org.jfw.util.PageQueryResult;

import java.sql.Connection;
import java.sql.SQLException;
import java.util.List;

/**
 * Created by TT on 2018/7/17.
 */
@DAO
public interface ProductDao {

    @SelectOne
    @Nullable
    Product queryById(Connection con, String id) throws SQLException;

    @PageQuery
    @OrderBy(" ORDER BY MODIFY_TIME DESC NULLS LAST")
    @Where("STATE = '1'")
    @Exclude("descp")
    PageQueryResult<ProductInfo> queryByTime(Connection con, @Nullable @Like String name, @SqlColumn(value = {"(p.name is null or p.name like ?)", "(o.name is null or o.name like ?)"}, handlerClass = StringHandler.class) String ownerName, @Nullable @GtEq @Alias("modifyTime") String bt, @Nullable @Alias("modifyTime") @LtEq String et, int pageSize, int pageNo) throws SQLException;

    @SelectList
    List<ProductPro> queryPro(Connection con, String id) throws SQLException;

    @UpdateWith
    @From(Product.class)
    @Where("STATE<>'0'")
    @SetSentence("STATE = '0'")
    int logicDelete(Connection con, String id) throws SQLException;

    @UpdateWith
    @From(Product.class)
    int updateKw(Connection con, String id, @Set String keywords) throws SQLException;

    @UpdateWith
    @From(Product.class)
    int updateSortFirst(Connection con, String id, @Set long sortFirst) throws SQLException;

    @DeleteWith
    @From(ProductPro.class)
    int deletePro(Connection con, String professor) throws SQLException;
}
