package com.ekexiu.console.system.service;

import com.ekexiu.console.system.dao.ProductDao;
import com.ekexiu.console.system.po.Product;
import com.ekexiu.console.system.po.ProductPro;
import com.ekexiu.console.system.pojo.ProductInfo;
import org.jfw.apt.annotation.Autowrie;
import org.jfw.apt.annotation.DefaultValue;
import org.jfw.apt.annotation.Nullable;
import org.jfw.apt.web.annotation.Path;
import org.jfw.apt.web.annotation.operate.Get;
import org.jfw.apt.web.annotation.operate.Post;
import org.jfw.apt.web.annotation.param.JdbcConn;
import org.jfw.apt.web.annotation.param.PathVar;
import org.jfw.util.PageQueryResult;

import java.sql.Connection;
import java.sql.SQLException;
import java.util.List;

/**
 * Created by TT on 2018/7/17.
 */
@Path("/product")
public class ProductService {
    @Autowrie
    private ProductDao productDao;
    @Autowrie
    private KeyWordService keyWordService;

    public ProductDao getProductDao() {
        return productDao;
    }

    public void setProductDao(ProductDao productDao) {
        this.productDao = productDao;
    }

    public KeyWordService getKeyWordService() {
        return keyWordService;
    }

    public void setKeyWordService(KeyWordService keyWordService) {
        this.keyWordService = keyWordService;
    }

    @Get
    @Path("/id/{id}")
    public Product query(@JdbcConn Connection con, @PathVar String id)throws SQLException {
        return this.productDao.queryById(con, id);
    }

    @Path("/pq")
    @Get
    public PageQueryResult<ProductInfo> pageQueryResult(@JdbcConn Connection con, @Nullable String name, @Nullable String ownerName, @Nullable String bt, @Nullable String et, @DefaultValue("1") int pageNo, @DefaultValue("10") int pageSize)throws SQLException {
            return this.productDao.queryByTime(con, name == null ? null : "%" + name + "%",  ownerName == null ? "%" : "%" + ownerName + "%", bt == null ? null : bt + "000000", et == null ? null : et + "235959", pageSize, pageNo);
    }

    @Path("/linkman")
    @Get
    public List<ProductPro> queryLinkman(@JdbcConn Connection con,String id)throws SQLException {
        return this.productDao.queryPro(con, id);
    }

    @Path("/delete")
    @Post
    public void delete(@JdbcConn(true) Connection con,String id) throws SQLException {
        this.productDao.logicDelete(con, id);
    }

    @Post
    @Path("/kw")
    public void updateKw(@JdbcConn(true)Connection con,String id,@Nullable String kw)throws SQLException {
        this.productDao.updateKw(con, id, kw);
        this.keyWordService.refreshProduct(con, id, kw);
    }

    @Post
    @Path("/sortFirst")
    public void updateSortFirst(@JdbcConn(true)Connection con,String id,long sortFirst)throws SQLException {
        this.productDao.updateSortFirst(con, id, sortFirst);
    }

}
